=== debian/changelog ===
civetweb (1.13+dfsg-5) unstable; urgency=medium

  * Team Upload.
  * Build-Depend on libjs-jquery and use
    minified file provided in this binary
    (Closes: #980674)

 -- Nilesh Patra <npatra974@gmail.com>  Thu, 21 Jan 2021 20:00:38 +0530

civetweb (1.13+dfsg-4) unstable; urgency=medium

  [ Timo Röhling ]
  * build C++ API as well
    Closes: #974775

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Sat, 05 Dec 2020 15:47:00 +0100

civetweb (1.13+dfsg-3) unstable; urgency=medium

  * Fix SOVERSION of the shared library to create "libcivetweb.so.1"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 03 Nov 2020 15:42:33 +0100

civetweb (1.13+dfsg-2) unstable; urgency=medium

  * Upgraded "debian/patches/webdav-uploads" for civetweb 1.13

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 27 Oct 2020 13:40:23 +0100

civetweb (1.13+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Add symbols file

 -- Andreas Tille <tille@debian.org>  Tue, 27 Oct 2020 09:06:32 +0100

civetweb (1.12+dfsg-5) unstable; urgency=medium

  * Patch to support uploads in WebDAV

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Fri, 16 Oct 2020 13:40:00 +0200

civetweb (1.12+dfsg-4) unstable; urgency=medium

  * Fix my forgetting of tagging Helmut's issue as closed (Closes: #970544)

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 19 Sep 2020 11:51:51 +0200

civetweb (1.12+dfsg-3) unstable; urgency=medium

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Don't use arch-dependent paths in *.install files

  [ Sebastien Jodogne ]
  * Add function to improve the performance of Orthanc on keep-alive

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sat, 19 Sep 2020 10:52:31 +0200

civetweb (1.12+dfsg-2) unstable; urgency=medium

  * Source-only upload
  * Remove trailing whitespace in debian/copyright (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 17 Sep 2020 09:27:48 +0200

civetweb (1.12+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #970358)

 -- Andreas Tille <tille@debian.org>  Tue, 15 Sep 2020 14:20:35 +0200
