=== debian/control ===
Source: civetweb
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sebastien Jodogne <s.jodogne@gmail.com>
Section: web
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/civetweb
Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
Homepage: https://github.com/civetweb/civetweb/
Rules-Requires-Root: no

Package: civetweb
Architecture: any
Depends: libcivetweb1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.

Package: libcivetweb1
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support (lib)
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.
 .
 This package contains the shared library for civetweb.

Package: libcivetweb-dev
Architecture: any
Section: libdevel
Depends: libcivetweb1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: embeddable web server with optional CGI, SSL and Lua support (devel)
 CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
 with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
 you can innovate without restrictions.
 .
 CivetWeb can be used by developers as a library, to add web server
 functionality to an existing application.
 .
 It can also be used by end users as a stand-alone web server running on
 a Windows or Linux PC. It is available as single executable, no
 installation is required.
 .
 This package contains the header file for developing applications using
 civetweb.
