## civetweb 1.15+dfsg

=== debian/changelog ===
civetweb (1.15+dfsg-3) unstable; urgency=medium

  * Provide symbols for amd64 architecture only to reduce burden of
    maintenance

 -- Andreas Tille <tille@debian.org>  Tue, 07 Dec 2021 16:25:40 +0100

civetweb (1.15+dfsg-2) unstable; urgency=medium

  * Add websockets support
    Closes: #989287
  * For whatever reason dh_makeshlibs adds extra symbols including Debian
    revision.  Providing the result from that process as new symbols file
    after stripping revision

 -- Andreas Tille <tille@debian.org>  Tue, 07 Dec 2021 15:45:21 +0100

civetweb (1.15+dfsg-1) unstable; urgency=medium

  * Fix watchfile to detect new versions on github
  * New upstream version
  * Standards-Version: 4.6.0 (routine-update)
  * Remove Debian revision from symbols

 -- Andreas Tille <tille@debian.org>  Wed, 13 Oct 2021 09:36:08 +0200
