=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
                libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/med-team/civetweb
 Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
 Homepage: https://github.com/civetweb/civetweb/
@@ -35,6 +35,7 @@
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: embeddable web server with optional CGI, SSL and Lua support (lib)
  CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
  with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
@@ -55,6 +56,7 @@
 Depends: libcivetweb1 (= ${binary:Version}),
          ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: embeddable web server with optional CGI, SSL and Lua support (devel)
  CivetWeb is an easy to use, powerful, C (C/C++) embeddable web server
  with optional CGI, SSL and Lua support. CivetWeb has a MIT license so
