=== debian/rules ===
--- 
+++ 
@@ -12,7 +12,8 @@
         -DCIVETWEB_BUILD_TESTING=OFF \
         -DCIVETWEB_SOVERSION=1 \
 	-DCIVETWEB_ENABLE_CXX=ON \
-        -DBUILD_SHARED_LIBS=ON
+        -DBUILD_SHARED_LIBS=ON \
+        -DCIVETWEB_ENABLE_WEBSOCKETS=ON
 
 %:
 	dh $@ --buildsystem=cmake
