=== debian/changelog ===
civetweb (1.16+dfsg-1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:44:05 +0200

civetweb (1.16+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Sebastien Jodogne ]
  * Update symbols file (Closes: #1037603)

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Remove constraints unnecessary since bullseye (oldstable):
    + Build-Depends: Drop versioned constraint on libjs-jquery (>=
      3.5.1+dfsg+~3.5.5-7).
  * Install pkgconfig files
  * Update symbols

  [ Étienne Mollier ]
  * d/libcivetweb1.symbols.amd64: update symbol table some more.  Changes
    include the marking of a couple of symbols leaked by g++ as optional.
  * d/rules: move pkgconfig files.  Their content is architecture specific, so
    they must relocate to an architecture specific directory.

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Jul 2023 19:30:39 +0200

civetweb (1.15+dfsg-4) unstable; urgency=medium

  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 01 Nov 2022 20:04:28 +0100
