=== debian/changelog ===
civetweb (1.16+dfsg-3) unstable; urgency=medium

  * Team upload.
  * debian/rules: Set cmake minimum version to 3.5 (Closes: #1112780)
  * Cherry-pick proposed patch for CVE-2025-55763

 -- Andreas Henriksson <andreas@fatal.se>  Sat, 27 Sep 2025 01:10:04 +0200

civetweb (1.16+dfsg-2) unstable; urgency=medium

  * Unfuzz patches.
  * d/control: add myself to uploaders.
  * d/control: declare compliance to standards version 4.7.0.
  * d/libcivetweb1.symbols.amd64: mark compiler symbols optional.
    (Closes: #1015368, #1074884)
  * d/rules: forcefully rule LTO builds.
  * d/clean: new: cleanup test/ajax/jquery.js. (Closes: #1043758)
  * d/libcivetweb1.symbols.amd64: specify B-D-P: libcivetweb-dev.

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Jul 2024 23:23:09 +0200
