=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: civetweb
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Andreas Tille <tille@debian.org>,
-           Sebastien Jodogne <s.jodogne@gmail.com>
+           Sebastien Jodogne <s.jodogne@gmail.com>,
+           Étienne Mollier <emollier@debian.org>
 Section: web
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               libjs-jquery (>= 3.5.1+dfsg+~3.5.5-7)
-Standards-Version: 4.6.0
+               libjs-jquery
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/civetweb
 Vcs-Git: https://salsa.debian.org/med-team/civetweb.git
 Homepage: https://github.com/civetweb/civetweb/
